# How to Proxmox

Proxmox est une solution open source de virtualisation. Il offre une API
et une interface web afin de permettre de facilement controllé des machines
virtuelles, des conteneurs le stockage, le réseau, la haute disponibilité
et bien d'autres choses.

## Surveillance

Il est possible de surveiller un cluster proxmox en utilisant https://github.com/nbuchwitz/check_pve

## Mise à jour d'une version majeure de Proxmox VE

Lors d'une nouvelle version de Debian, Proxmox mets à jours sa distribution et ses outils.

A chaque version majeure, proxmox publie un documentation d'upgrade avec l'URL sou cette forme :  https://pve.proxmox.com/wiki/Upgrade_from_X_to_X

### Exemple de mise à jour de Proxmox VE 7 vers Proxmox VE 8

Pour la mise à jour de Proxmox VE 7 vers Proxmox VE 8, il faut se référer à la documentation suivante, pour les cas particulier ou les problèmes éventuel : [https://pve.proxmox.com/wiki/Upgrade_from_7_to_8](https://pve.proxmox.com/wiki/Upgrade_from_7_to_8)

Voici les étapes à suivre lors de la mise à jour :

* Migré les VMs critique sur un des autres nœuds Proxmox et arrêter les VMs non critique.
* Vérifié que toutes les mises à jours mineure et de sécurité sont faites sur la version courante.
* Faire la mise à jour soit par SSH soit via la console, directement sur le nœud que l'on veux mettre à jour.
* Utiliser l'outil `pve7to8` qui fait un checklist avant la mise à jour comme ceci :

~~~
# root@proxmoxdev:~#  pve7to8 --full
~~~

On l'exécute avec l'option `--full` pour avoir toutes la checklist complète, il ne faut pas qu'il y est d'erreurs ou de warning, sinon il faut réglé les warnings remontées par l'outil avant de passer à l'étape suivante.

* On change les dépôts pour la nouvelle version de Debian :

~~~
# sed -i 's/bullseye/bookworm/g' /etc/apt/sources.list
~~~

Si on utilise le dépôt Proxmox `No-Subscription` il faut rajouter ce dépôt à `/etc/apt/sources.list` :

~~~
# Proxmox VE pve-no-subscription repository provided by proxmox.com,
# NOT recommended for production use
deb http://download.proxmox.com/debian/pve bookworm pve-no-subscription
~~~

* On peux commencer la mise à jour avec les commandes suivantes :

~~~
# apt update
# apt dist-upgrade
~~~

Durant le processus de mise à jour, des questions au niveau du remplacement de fichier de configuration peuvent être poser, voici les fichiers qui reviennent le plus souvent lors de la mise à jour de Proxmox VE 7 vers Proxmox VE 8 :

* `/etc/issue` -> Proxmox générera automatiquement ce fichier au démarrage, et il n'a que des effets cosmétiques sur la console de connexion.
L'utilisation de la valeur par défaut "Non" (conservez votre version actuellement installée) est sûre ici.

* `/etc/lvm/lvm.conf` -> Si vous n'avez pas apporté de modifications supplémentaires vous-même et que vous n'êtes pas sûr, il est suggéré de choisir "Oui" (installer la version du responsable du paquet) ici.


* Une fois la mise à jour terminé, on peux redémarrer l'hyperviseur.

* On peux re-jouer la commande `pve7to8` et vérifié les warnings.
* On peux se reconnecter à l'interface web, il faut supprimer le cache navigateur avec CTRL + SHIFT + R.